import React, { useState } from 'react';
const reactHookStateMock = (states) => {
    if (global.__jestReactHooksMockSpy) {
        global.__jestReactHooksMockSpy.mockRestore();
    }
    const originalUseState = useState;
    let stateIndex = 0;
    let mockedSets = [];
    let mockedSetsTest = [];
    let mocksCreated = false;
    let stateValues = {};
    const createGetterCurrentMockedSets = (_stateIndex) => {
        return (value) => {
            mockedSets[_stateIndex](value);
        };
    };
    return new Promise(resolve => {
        global.__jestReactHooksMockSpy = jest.spyOn(React, 'useState').mockImplementation(function () {
            const [value, set] = originalUseState(arguments[0]);
            const fieldName = states[stateIndex];
            stateValues[fieldName] = value;
            const mockedSet = (newValue) => {
                stateValues[fieldName] = newValue;
                set(newValue);
            };
            mockedSets.push(mockedSet);
            if (!mocksCreated) {
                mockedSetsTest.push(createGetterCurrentMockedSets(stateIndex));
            }
            stateIndex += 1;
            if (stateIndex === states.length) {
                stateIndex = 0;
                if (!mocksCreated) {
                    resolve([stateValues, mockedSetsTest]);
                }
                mocksCreated = true;
            }
            return [value, mockedSet];
        });
    });
};
export default reactHookStateMock;
